%define deftclver 8.4.5
%define tclver %(rpm -q tcl --queryformat '%%{version}' 2> /dev/null || echo %{deftclver})

#Module-Specific definitions
%define mod_version 1.0
%define mod_name mod_tcl
%define mod_conf 27_%{mod_name}.conf
%define mod_so %{mod_name}.so
%define sourcename %{mod_name}-%{mod_version}

%define apache_version 2.0.53

# Standard Module Definitions
%define name apache2-%{mod_name}
%define version %{apache_version}_%{mod_version}

Summary:	Mod_tcl is a DSO module for the apache2 Web server
Name:		%{name}
Version:	%{version}
Release:	%mkrel 4
Group:		System/Servers
License:	Apache License
URL:		http://tcl.apache.org/mod_tcl/
Source0:	%{mod_name}.tar.bz2
Source1:	%{mod_conf}.bz2
Source2:	test_script.tm.bz2
Patch:		mod_tcl-fix-wild_name.bz2
Prereq:		rpm-helper
Requires:	tcl = %{tclver}
BuildPrereq:	tcl = %{tclver}
Prereq:		tcl = %{tclver}
Prereq:		apache2 >= %{apache_version}
Prereq:		apache2-conf
BuildRequires:	apache2-devel >= %{apache_version}-1mdk
BuildRequires:	file
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
mod_tcl includes a Tcl interpreter into an Apache web servers
memory space, thus combining Tcl and Apache web server together.
This allows Apache to run Tcl scripts natively without having to
reload a Tcl interpreter every time the script is run. The Tcl
scripts are cached in the Tcl interpreter until the script file
modification time changes or Apache web server is restarted. Tcl
scripts using mod_tcl execute much faster than traditional CGI
scripts because they can avoid the initialization penalties that
traditional CGI scripts incur each time they are executed. mod_tcl
only needs to initialize an interpreter once at Apache web server
startup. Additionally mod_tcl exports the Apache API which allows
a programmer to have complete control over http requests that CGI
scripts can not provide.

%prep

%setup -q -n %{mod_name}-%{mod_version}
%patch0
bzcat %{SOURCE2} > test_script.tm

# strip away annoying ^M
find . -type f|xargs file|grep 'CRLF'|cut -d: -f1|xargs perl -p -i -e 's/\r//'
find . -type f|xargs file|grep 'text'|cut -d: -f1|xargs perl -p -i -e 's/\r//'

%build

cp tcl_core.c %{mod_name}.c 

# use stuff availble to determine stuff... :-)
. %{_libdir}/tclConfig.sh

#%{_sbindir}/apxs2 -c -I%{_includedir} -Wl,-ltcl8.3 -DHAVE_TCL_H %{mod_name}.c tcl_cmds.c tcl_misc.c
%{_sbindir}/apxs2 -c -I%{_includedir} -Wl,$TCL_LIB_FLAG -DHAVE_TCL_H %{mod_name}.c tcl_cmds.c tcl_misc.c

##############################################################################
# NOTE! As I don't know TCL, I don't have a clue how to use this
# module..., but anywhere here it is. The module may require
# other things I'm unaware of, please don't shoot me ;)
# -- 
# Regards // Oden Eriksson
# Deserve-IT Networks http://d-srv.com
##############################################################################

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}%{_libdir}/apache2-extramodules
install -d %{buildroot}%{_sysconfdir}/httpd/conf.d

install -m0755 .libs/*.so %{buildroot}%{_libdir}/apache2-extramodules/
bzcat %{SOURCE1} > %{buildroot}%{_sysconfdir}/httpd/conf.d/%{mod_conf}

install -d %{buildroot}%{_var}/www/html/addon-modules
ln -s ../../../..%{_docdir}/%{name}-%{version} %{buildroot}%{_var}/www/html/addon-modules/%{name}-%{version}

%post
if [ -f %{_var}/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun
if [ "$1" = "0" ]; then
    if [ -f %{_var}/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc AUTHORS INSTALL NEWS README test_script.tm
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf.d/%{mod_conf}
%attr(0755,root,root) %{_libdir}/apache2-extramodules/%{mod_so}
%{_var}/www/html/addon-modules/*

%changelog
* Sun Mar 20 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.0-4mdk
- use the %%mkrel macro

* Mon Feb 28 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.0-3mdk
- fix %%post and %%postun to prevent double restarts
- fix bug #6574

* Wed Feb 16 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.0-2mdk
- spec file cleanups, remove the ADVX-build stuff

* Tue Feb  8 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.0-1mdk
- rebuilt for apache 2.0.53

* Tue Sep 28 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.52_1.0-1mdk
- built for apache 2.0.52

* Thu Sep 16 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.51_1.0-1mdk
- built for apache 2.0.51

* Mon Jul 12 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.50_1.0-1mdk
- built for apache 2.0.50
- remove redundant provides

* Mon Jun 14 2004 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.49_1.0-1mdk
- built for apache 2.0.49

* Tue Feb 24 2004 Pascal Terjan <pterjan@mandrake.org> 2.0.48_1.0-2mdk
- built for new tcl

* Wed Nov 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.48_1.0-1mdk
- built for apache 2.0.48

* Thu Jul 10 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_1.0-1mdk
- rebuilt against latest apache2, requires and buildrequires

* Sat May 31 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.46_1.0-1mdk
- rebuilt for apache v2.0.46
- buildprereq ADVX-build >= 9.2

* Tue Apr 08 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.45_1.0-1mdk
- rebuilt against tcl-8.4.2
- cosmetic rebuild for apache v2.0.45 
- use %{_libdir}/tclConfig.sh to determine stuff...

* Sat Mar  1 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.44_1.0-3mdk
- fix segfault with names and wild_names record_rec structures when they are
  empty. 
- improve configuration file and test script.
- TODO: send these modifications to the mod_tcl team, since they are not MDK
  specific.

* Sat Mar  1 2003 Jean-Michel Dault <jmdault@mandrakesoft.com> 2.0.44_1.0-2mdk
- rebuild

* Tue Jan 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.44_1.0-1mdk
- rebuilt for apache v2.0.44

* Mon Jan 20 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_1.0-4mdk
- fix buildrequires apache2-devel >= 2.0.53-1mdk, as 
  pointed out by Olivier Thauvin

* Sat Jan 18 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_1.0-3mdk
- rebuilt against rebuilt buildrequires

* Mon Jan 13 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_1.0-2mdk
- Rebuilt with the new apache-devel that uses /usr/sbin/apxs2 and
  /usr/include/apache2

* Tue Nov 05 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.43_1.0-1mdk
- initial cooker contrib
